# Note that this is NOT a relocatable package
%define ver      0.8.0
%define rel      1jp
%define prefix   /usr

%define config_opts --prefix=%{prefix} --sysconfdir=/etc --enable-threads --disable-system-install

Summary:   Balsa Mail Client
Name:      balsa
Version:   %ver
Release:   %rel
Copyright: GPL
Group:     Applications/Internet
Source0:   balsa-%{PACKAGE_VERSION}.tar.gz
Patch1:	   ./rpm-po.patch
URL:       http://www.balsa.net/
BuildRoot: /tmp/balsa-%{PACKAGE_VERSION}-root
Packager: Michael Fulbright <msf@redhat.com>
Requires: gtk+ >= 1.2.0
Requires: gnome-libs >= 1.0.0
Docdir: %{prefix}/doc

%description
Balsa is an e-mail reader.  This client is part of the GNOME
desktop environment.  It supports local mailboxes, POP3 and
IMAP.
 
%prep
%setup
%patch1

%build
# Needed for snapshot releases.
if [ ! -f configure ]; then
%ifarch alpha
  CFLAGS="$RPM_OPT_FLAGS" ./autogen.sh --host=alpha-redhat-linux %{config_opts}
%else
  CFLAGS="$RPM_OPT_FLAGS" ./autogen.sh %{config_opts}
%endif
else
%ifarch alpha
  CFLAGS="$RPM_OPT_FLAGS" ./configure --host=alpha-redhat-linux %{config_opts}
%else
  CFLAGS="$RPM_OPT_FLAGS" ./configure %{config_opts}
%endif
fi

if [ "$SMP" != "" ]; then
  (make "MAKE=make -k -j $SMP"; exit 0)
  make
else
  make CFLAGS="$RPM_OPT_FLAGS"
fi

%install
rm -rf "$RPM_BUILD_ROOT"

make sysconfdir=/etc  DESTDIR="$RPM_BUILD_ROOT" install

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root)
%doc README COPYING ChangeLog NEWS TODO
%{prefix}/bin/balsa
/usr/share/gnome/apps/Internet/balsa.desktop
%{prefix}/share/gnome/help/balsa/*
%{prefix}/share/idl/balsa.idl
/usr/share/locale/*
/usr/share/pixmaps/*
/usr/share/sounds/balsa/*
%{prefix}/man/*
%config /etc/CORBA/servers/balsa.gnorba
%config /etc/sound/events/*


%changelog
* Thu Dec 30 1999 Bruno Pires Marinho <bapm@camoes.rnl.ist.utl.pt>

- Improved the spec file by adding a sysconfdir=/etc, removing the man
  instalation because balsa does it now and adding the files on the /etc
  to the distribution

* Tue Oct  5 1999 Jan Nieuwenhuizen <janneke@gnu.org>

- Fixed man install

* Sun Sep 26 1999 Stuart Parmenter <pavlov@balsa.net>

- Updated to version 0.5.0

* Mon Dec 14 1998 Stuart Parmenter <pavlov@pavlov.net>

- Updated to version 0.4.8.

* Sun Sep 09 1998 Stuart Parmenter <pavlov@pavlov.net>

- Updated to version 0.4.7.

* Sun Aug 23 1998 Stuart Parmenter <pavlov@pavlov.net>

- Updated to version 0.4.5.

* Mon Aug  3 1998 Stuart Parmenter <pavlov@pavlov.net>

- Updated to version 0.4.0.

* Sun Jul 26 1998 Stuart Parmenter <pavlov@pavlov.net>

- Updated RPM file to reflect recent changes with the
  removal of c-client.

* Thu Apr 02 1998 Michael Fulbright <msf@redhat.com>

- First try at an RPM
